Attribute VB_Name = "Module3"
'//
'// Module HiScores
'//



'// Hi-Scores table //
Public Type HiScType
    hsName As String                       ' = Player initials
    hsLevel As Integer                     ' = Level
    hsScore As Long                        ' = Score
End Type
Public HiScores(1 To 12) As HiScType       ' Hi-Scores table
Public HiScoreLevel(1 To 180) As HiScType  ' Hi-Score Level table



'// Load HiScores //
Public Sub LoadHiScores()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HiScores.DAT"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Get #FF, , HiScores()
    Close #FF

End Sub

'// Load HiScoreLevel //
Public Sub LoadHiScoreLevel()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HiScoreLevel.DAT"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Get #FF, , HiScoreLevel()
    Close #FF

End Sub

'// Save HiScores //
Public Sub SaveHiScores()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HiScores.DAT"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Put #FF, , HiScores()
    Close #FF

End Sub

'// Save HiScoreLevel //
Public Sub SaveHiScoreLevel()
    
    Dim HiScFileName As String, FF As Integer
    HiScFileName = App.Path & "\HiScoreLevel.DAT"
        
    FF = FreeFile
    
    Open HiScFileName For Binary As #FF
    Put #FF, , HiScoreLevel()
    Close #FF

End Sub

'// Checks if last score is a new high-score //
Public Function IsHiScore(Score As Long) As Integer
    
    IsHiScore = 0 ' Ret = 0 (No high-score)
    
    Dim Index As Integer
    Dim I As Integer, J As Integer
    
    Select Case Speed
        Case SPEED_SUPER
            Index = 1
        Case SPEED_FAST
            Index = 4
        Case SPEED_NORMAL
            Index = 7
        Case SPEED_SLOW
            Index = 10
    End Select
    
    For I = Index + 2 To Index Step -1
        If Score > HiScores(I).hsScore Then
            For J = Index + 2 To I + 1 Step -1
                HiScores(J).hsName = HiScores(J - 1).hsName
                HiScores(J).hsLevel = HiScores(J - 1).hsLevel
                HiScores(J).hsScore = HiScores(J - 1).hsScore
            Next J
            ' Ret = Index (New high-score)
            IsHiScore = I
        End If
    Next I
        
End Function

'// Checks if level score is a new high-score //
Public Function IsLevelHiScore(Score As Long) As Integer
    
    IsLevelHiScore = 0 ' Ret = 0 (No level high-score)
    
    Dim Index As Integer
    Dim I As Integer
    
    Select Case Speed
        Case SPEED_SUPER
            Index = 0
        Case SPEED_FAST
            Index = 45
        Case SPEED_NORMAL
            Index = 90
        Case SPEED_SLOW
            Index = 135
    End Select
    
    If Score > HiScoreLevel(Index + Level).hsScore Then
        IsLevelHiScore = Index + Level ' New level high-score
    End If
    
End Function

